
#ifndef TEXTURE_H
#define TEXTURE_H
#if defined(ENABLE_DISPLAY)
#include <string>
#include <list>


/*! \brief This class is used to display textures with OpenGL. */
class Texture
{
 public:
  std::string name; /*!< name of the texture */ 

  unsigned int width; /*!< width of the texture */ 
  unsigned int height; /*!< height of the texture */ 
  unsigned char *data; /*!< the pixel map (stored line by line with interlaced channels: in the order RGB RGB RGB...): an array of 3*width*height size */
  GLuint genName; /*!< a texture number used by OpenGL */ 

  Texture()
  {
    name= "none";
    width= height= 0;
    data= NULL;
  };

  Texture(std::string _name, unsigned int size, unsigned int square_number);
  ~Texture();
}; 


/*! \brief This class is used to store a list of textures. */
class TextureList
{
 public:
  std::list<Texture*> list;
  
  ~TextureList();

  int addTexture(std::string name);
  int loadTexture(std::string name);
};

#endif

#endif
