
#include <bounding_volume.h>

BoundingSphere::BoundingSphere()
{
  _radius = -1.0;
}

BoundingSphere::BoundingSphere(const BoundingSphere &s)
{
  _radius = s._radius;
  _center = s._center;
}

BoundingSphere::BoundingSphere(const Vector3D &center)
{
  _center= center;
  _radius = 0 + 1e-4;
}

BoundingSphere::BoundingSphere(const Vector3D &center, float radius)
{
  _center= center;
  _radius = radius;
}

BoundingSphere::BoundingSphere(const Vector3D &p1, const Vector3D &p2)
{
  Vector3D c= (p1 + p2)/2.0;
  _center= c;
  _radius = norm(p1-p2);
}

BoundingSphere::BoundingSphere(const Vector3D &p1, const Vector3D &p2, const Vector3D &p3)
{
  float denominator;
  Vector3D a, b, a_x_b;

  a= p2 - p1;
  b= p3 - p1;

  a_x_b= crossProduct(a, b);

  denominator= 2.0*dotProduct(a_x_b, a_x_b);

  if(denominator < 1e-6) // the points are aligned
  {
    if(dotProduct(a, b) < 0) // p1 is between p2 and p3
    { 
      _center= 0.5*(p2 + p3);
      _radius= norm(p2-p3);
    }
    else if(dotProduct(p1-p2, p3-p2) < 0) // p2 is between p1 and p3
    { 
      _center= 0.5*(p1 + p3);
      _radius= norm(p1-p3);
    }
    else // p3 is between p1 and p2
    { 
      _center= 0.5*(p1 + p2);
      _radius= norm(p1-p2);
    }
  }
  else
  {
    _center= ( dotProduct(b, b)*(crossProduct(a_x_b, a)) + dotProduct(a, a)*(crossProduct(b, a_x_b)) ) / denominator;
    _radius= norm(p1);
  }

}

BoundingSphere::BoundingSphere(const Vector3D &p1, const Vector3D &p2, const Vector3D &p3, const Vector3D &p4)
{


} 


/*


	Sphere::Sphere(const Point &O, const Point &A)
	{
		Vector a = A - O;

		Vector o = 0.5f * a;

		radius = Vector::N(o) + radiusEpsilon;
		center = O + o;
	}

	Sphere::Sphere(const Point &O, const Point &A,  const Point &B)
	{
		Vector a = A - O;
		Vector b = B - O;

		float Denominator = 2.0f * ((a % b) * (a % b));

		Vector o = ((b^2) * ((a % b) % a) +
		            (a^2) * (b % (a % b))) / Denominator;

		radius = Vector::N(o) + radiusEpsilon;
		center = O + o;
	}

	Sphere::Sphere(const Point &O, const Point &A, const Point &B, const Point &C)
	{
		Vector a = A - O;
		Vector b = B - O;
		Vector c = C - O;

		float Denominator = 2.0f * Matrix::det(a.x, a.y, a.z,
		                                       b.x, b.y, b.z,
		                                       c.x, c.y, c.z);

		Vector o = ((c^2) * (a % b) +
		            (b^2) * (c % a) +
		            (a^2) * (b % c)) / Denominator;

		radius = Vector::N(o) + radiusEpsilon;
		center = O + o;
	}*/
